/*
  isprime.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <libgen.h>
#include <gmpxx.h>

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [number ...]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  mpz_class n;

  if (argc < 2) return usage(std::cerr, argc, argv);
  for (a=1; a<argc; ++a) {
    n = argv[a];
    if (!mpz_probab_prime_p(n.get_mpz_t(), 25))
      return 1;
  }
  return 0;
}
